ChUI CHOOSE characters are too choosey
Description

History

#1 - 03/31/2021 03:27 PM - Roger Borrello

I am almost complete with revising CHOOSE so that it can react to any characters that are being pressed. Previously it could only react to

alphanumeric, but in thi testcases I can see it should react to any valid keystroke.

def var l-noerr as log.

message "no-error?" update l-noerr.

def var l-fkeys as log.

message "Mod-fkeys?" update l-fkeys.

if l-fkeys then do:

  on f9 new-line.

  on f10 delete-line.

end.  

def var lst as char extent 5 init ["One", "Two", "Three", "Four", "Five"].

def var dlst as decimal extent 5 init [0.01, 1.02, 1.10, 3.20, 4.50]. 

def var i as int init 1.

def var str as char.

def var choice as char.

form str with 4 down frame f0.

repeat with frame f0:

    str = string(dlst[i]). i = i + 1. display str. down.

    if i = 5 then do:

        up. leave.

    end.

end.

repeat with frame f0:

    if l-noerr then choose row str auto-return no-error.

         else choose row str auto-return.

    message l-noerr "/" l-fkeys keylabel(lastkey) keyfunction(lastkey) string(frame-line) + " " + string(frame

-down).

end.
#2 - 03/31/2021 03:27 PM - Roger Borrello

- Assignee set to Roger Borrello

- Status changed from New to WIP

#3 - 03/31/2021 07:46 PM - Roger Borrello

The documentation indicates KEYCODE(RETURN) is returned when AUTO-RETURN is set, and a match is found.

#4 - 04/05/2021 05:52 PM - Roger Borrello

- Status changed from WIP to Review

- % Done changed from 0 to 100

Updated in 3821c_12248. Please review.

#5 - 04/05/2021 06:44 PM - Greg Shah

- Status changed from Review to Test

Code Review Task Branch 3821c Revision 12248

The changes are good.

#6 - 04/05/2021 06:46 PM - Greg Shah

- Status changed from Test to Closed
